
#include "sccp.h"
/*-------------------------------SCCP-------------------------------*/

/*指令支持*/
// phi函数求值；
void EvaluateOperands(int curB, string curV)
{
    if (g_sscpS.find(curV)->SLattice.status != bottom)
    {
        for (auto itpP = g_bbL.find(g_sscpS.now_func, curB)->phi_nodes[curV].begin(); itpP != g_bbL.find(g_sscpS.now_func, curB)->phi_nodes[curV].end(); itpP++) //对于每一个phi参数；
        {
            if (executedCEList.find(itpP->index) != executedCEList.end()) //如果所在的块已执行；
            {
                g_sscpS.find(itpP->phiIRSite->opn1.id)->varMeet(itpP->phiIRSite, g_sscpS.find(itpP->phiIRSite->opn2.id)); //传播phi函数的参数->返回值赋值语句；
            }
        }
        for (auto itn = g_sscpS.find(g_bbL.find(g_sscpS.now_func, curB)->alive_VB[curV])->useSite.begin(); itn != g_sscpS.find(g_bbL.find(g_sscpS.now_func, curB)->alive_VB[curV])->useSite.end(); itn++) //将所有的后继加入工作表；
        {
            SSAEdge tmpe;
            tmpe.in.emplace(g_bbL.find(g_sscpS.now_func, curB)->alive_VB[curV]);
            tmpe.op = "=";
            tmpe.edgeIR = itn->codePr;
            if (itn->codePr->op == IR_ASSIGN)
                SSAworkList[itn->codePr->opn1.id].emplace(tmpe);
            else if (itn->codePr->op == IR_LOAD)
                SSAworkList[itn->codePr->result.id].emplace(tmpe);
        }
    }
}

//处理普通指令：
void EvaluateAssign(codenode *curC) //处理一个块上的非条件，非phi语句；
{
    switch (curC->op)
    {
    case IR_ASSIGN:
    {
        // cout << "\t通过assign传播至 " << curC->opn1.id << "\t" << curC->opn1.kind << endl;
        if ((curC->opn1.kind == 'S' || curC->opn1.kind == 'T') && curC->opn1.id != "r0")
        {
            g_sscpS.find(curC->opn1.id)->varMeet(curC, g_sscpS.find(curC->opn2.id));
            SSAEdge tmpe(curC->opn2.id, "=", curC);
            SSAworkList[curC->opn1.id].emplace(tmpe);
        }
        break;
    }
    case IR_LOAD:
    {
        // cout << "\t通过load传播至" << curC->result.id << endl;
        if (curC->result.kind == 'S' || curC->result.kind == 'T')
        {
            g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn1.id));
            SSAEdge tmpe(curC->opn1.id, "=", curC);
            SSAworkList[curC->result.id].emplace(tmpe);
        }
        break;
    }
    case IR_ADD:
    case IR_MINUS:
    case IR_MUL:
    case IR_DIV:
    case IR_MOD:
    {
        // cout << "\t通过add传播至 " << curC->result.id << endl;
        struct CTStruct tmpS;
        if (curC->opn2.type != 'v')
        {
            SetCTStruct(tmpS, curC->opn2);
            g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn1.id), &tmpS);
        }
        else if (curC->opn1.type != 'v')
        {
            SetCTStruct(tmpS, curC->opn1);
            g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn2.id), &tmpS);
        }
        else
            g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn1.id), g_sscpS.find(curC->opn2.id));

        SSAEdge tmpe(curC->opn2.id, curC->opn1.id, "=", curC);
        SSAworkList[curC->result.id].emplace(tmpe);
        break;
    }
    case IR_UMINUS:
    {
        g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn1.id));
        SSAEdge tmpe(curC->opn1.id, "=", curC);
        SSAworkList[curC->result.id].emplace(tmpe);
        break;
    }
    case IR_VCVT:
    {
        g_sscpS.find(curC->opn2.id)->varMeet(curC, g_sscpS.find(curC->result.id));
        SSAEdge tmpe(curC->result.id, "=", curC);
        SSAworkList[curC->opn2.id].emplace(tmpe);
        break;
    }

    case IR_JLT:
    case IR_JLE:
    case IR_JGT:
    case IR_JGE:
    case IR_EQ:
    case IR_NEQ:
    case IR_AND:
    case IR_OR:
    case IR_GOTO_JLT:
    case IR_GOTO_JLE:
    case IR_GOTO_JGT:
    case IR_GOTO_JGE:
    case IR_GOTO_NOT:
    case IR_GOTO_AND:
    case IR_GOTO_OR:
    case IR_GOTO_EQ:
    case IR_GOTO_NEQ:

    case IR_EXP_ARROFF:
    case IR_ARROFF_EXP:
    case IR_ARROFF_EXPi:
    case IR_EXP_ARROFFa:
    case IR_ARROFF_EXPi0:

    case IR_CALL:
    case IR_ALLOCA:
    case IR_FUNCTION:
    case IR_FUNC_END:
    case IR_PARAM:
    case IR_LABEL:
    case IR_GOTO:
    case BLOCK:
    case IR_ARG:
    case IR_RETURN:
    case IR_CALL_VOID:
    case ARM_MOVNE:
    case ARM_MOVEQ:
    default:
        break;
    }
}
//处理跳转指令：
void EvaluateConditional(codenode *curC) //只条件语句调用；
{
    switch (curC->op)
    {
    case IR_JLT:
    case IR_JLE:
    case IR_JGT:
    case IR_JGE:
    case IR_EQ:
    case IR_NEQ:
    {
        struct CTStruct tmpS;
        if (curC->opn2.type != 'v') //处理常数；
        {
            tmpS.VarName = "tmpConst";
            tmpS.type = 'v', tmpS.kind = 'T', tmpS.SLattice.status = value;
            tmpS.cal_type = curC->opn2.type;
            if (curC->opn2.type == 'i')
                tmpS.SLattice.intVal.emplace(curC->opn2.const_int);
            else
                tmpS.SLattice.floatVal.emplace(curC->opn2.const_float);

            g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn1.id), &tmpS);
            // cout << "neqOpn2:" << curC->opn2.id << "flag:" << curC->opn2.kind << endl;
        }
        else //直接meet；
            g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn1.id), g_sscpS.find(curC->opn2.id));

        if (g_sscpS.find(curC->result.id)->SLattice.status == value)
        {
            if (g_sscpS.find(curC->result.id)->cal_type == 'i')
            {
                if (*g_sscpS.find(curC->result.id)->SLattice.intVal.begin() == 0)
                {
                    curC->op = ARM_CPSR_Z0;
                    if (curC->gotoTCode != NULL)
                        curC->gotoTCode->op = IR_VOID;
                    struct codenode *now = curC;
                    while (now->op != IR_GOTO_NEQ && now->op != IR_GOTO_EQ && now->op != IR_LABEL)
                        now = now->next;
                    if (now->op == IR_GOTO_NEQ)
                    {
                        // cout << "goto:" << now->result.id << "\t" << now->result.type << endl;
                        now->op = IR_GOTO, now->opn1 = now->result;
                    }
                    else if (now->op == IR_GOTO_EQ)
                    {
                        now->op = IR_VOID, now->opn1 = now->result;
                    }
                }
                else if (*g_sscpS.find(curC->result.id)->SLattice.intVal.begin() != 0)
                {
                    curC->op = ARM_CPSR_Z1;
                    if (curC->gotoTCode != NULL)
                    {
                        curC->gotoTCode->op = IR_GOTO;
                        curC->gotoTCode->opn1 = curC->gotoTCode->result;
                    }
                    struct codenode *now = curC;
                    while (now->op != IR_GOTO_NEQ && now->op != IR_GOTO_EQ && now->op != IR_LABEL)
                        now = now->next;
                    if (now->op == IR_GOTO_NEQ)
                    {
                        now->op = IR_VOID, now->opn1 = now->result;
                    }
                    else if (now->op == IR_GOTO_EQ)
                    {
                        // cout << "goto:" << now->result.id << "\t" << now->result.type << endl;
                        now->op = IR_GOTO, now->opn1 = now->result;
                    }
                }
            }
            else if (g_sscpS.find(curC->result.id)->cal_type == 'f')
            {
                if (*g_sscpS.find(curC->result.id)->SLattice.floatVal.begin() == 0)
                {
                    curC->op = ARM_CPSR_Z0;
                    curC->gotoTCode->op = IR_VOID;
                    struct codenode *now = curC;
                    while (now->op != IR_GOTO_NEQ && now->op != IR_GOTO_EQ && now->op != IR_LABEL)
                        now = now->next;
                    if (now->op == IR_GOTO_NEQ)
                    {
                        now->op = IR_GOTO, now->opn1 = now->result;
                    }
                    else if (now->op == IR_GOTO_EQ)
                    {
                        now->op = IR_VOID, now->opn1 = now->result;
                    }
                }
                else if (*g_sscpS.find(curC->result.id)->SLattice.floatVal.begin() != 0)
                {
                    curC->op = ARM_CPSR_Z1;
                    if (curC->gotoTCode != NULL)
                    {
                        curC->gotoTCode->op = IR_GOTO;
                        curC->gotoTCode->opn1 = curC->gotoTCode->result;
                    }
                    struct codenode *now = curC;
                    while (now->op != IR_GOTO_NEQ && now->op != IR_GOTO_EQ && now->op != IR_LABEL)
                        now = now->next;
                    if (now->op == IR_GOTO_NEQ)
                    {
                        now->op = IR_VOID, now->opn1 = now->result;
                    }
                    else if (now->op == IR_GOTO_EQ)
                    {
                        // cout << "下降goto:" << now->result.id << "\t" << now->result.type << endl;
                        now->op = IR_GOTO, now->opn1 = now->result;
                    }
                }
            }
        }

        break;
    }
    case IR_NOT:
    {
        g_sscpS.find(curC->result.id)->varMeet(curC, g_sscpS.find(curC->opn1.id));
        SSAEdge tmpe(curC->opn1.id, "=", curC);
        SSAworkList[curC->result.id].emplace(tmpe);
        if (curC->gotoTCode != NULL)
        {
            if (g_sscpS.find(curC->result.id)->SLattice.status == value)
            {
                if (*g_sscpS.find(curC->result.id)->SLattice.intVal.begin() != 0)
                {
                    if (curC->gotoTCode != NULL)
                        curC->gotoTCode->op = IR_VOID;
                }
                else if (*g_sscpS.find(curC->result.id)->SLattice.intVal.begin() == 0)
                {
                    if (curC->gotoTCode != NULL)
                    {
                        curC->gotoTCode->op = IR_GOTO;
                        curC->gotoTCode->opn1 = curC->gotoTCode->result;
                    }
                }
            }
        }
        break;
    }

    default:
        break;
    }
}

//处理phi指令：
void EvaluatePhi(codenode *curC)
{
    string curV = curC->result.id;
    //对于d作为phi返回值的所有语句，遍历翻译后的所有赋值语句；
    //计算操作数，计算返回值；
    int toPhiB = curC->result.const_int;
    EvaluateOperands(toPhiB, curV);
    // EvaluateResult();
}

/*块支持*/
//处理CFG块输入phi指令：
void EvaluateAllPhisInBlock(int lastB, int curB)
{
    basic_block *B = g_bbL.find(g_sscpS.now_func, curB);
    //遍历Block中所有的phi函数；
    for (auto itp = B->phi_nodes.begin(); itp != B->phi_nodes.end(); itp++)
    {
        EvaluateOperands(curB, itp->first);
    }
}

//处理一个CFG块；
void EvaluateBlock(int lastB, int curB)
{
    codenode *begin = g_bbL.find(g_sscpS.now_func, curB)->begin, *end = g_bbL.find(g_sscpS.now_func, curB)->end, *cur = begin;
    EvaluateAllPhisInBlock(lastB, curB);      //处理输入的phi函数；
    for (; cur != end->next; cur = cur->next) //扫描代码并把后继加入；
    {
        if ((cur->op == IR_ASSIGN || cur->op == ARM_MOVcont) && cur->opn1.kind == 'H')
        {
            EvaluatePhi(cur);
        }
        else if ((cur->op > IR_MOD && cur->op < IR_AND) || cur->op == IR_NOT)
        {
            EvaluateConditional(cur);
        }
        else
        {
            EvaluateAssign(cur);
        }
    }
}

/*基于SCCP的死代码清理*/
void SCCPCodeDelete()
{
}

/* SCCP运行主体；*/
void FuncSCCPropagation()
{
    CFGworkList.clear(), SSAworkList.clear();
    CFGworkList[0].emplace(0); //初始化控制流工作表为0-0边；

    executedCEList.clear(); //所有控制流边都初始化为未执行；

    DFSBlockSSCPInit(0); // DFS所有的块并进行变量初始化；

    while (!(CFGworkList.empty() && SSAworkList.empty()))
    {
        if (!CFGworkList.empty())
        {
            //取出并删除一个边；
            int curB = CFGworkList.begin()->first, lastB;
            if (CFGworkList.begin()->second.size() == 0)
            {
                cout << "函数: " << g_sscpS.now_func << "存在空控制流边：" << CFGworkList.begin()->first << endl;
                lastB = curB;
            }
            else
                lastB = *CFGworkList.begin()->second.begin();

            CFGworkList[curB].erase(lastB); //工作表中删除此边；

            //对取出的边进行处理；
            if (!(executedCEList.find(curB) != executedCEList.end() && executedCEList[curB].find(lastB) != executedCEList[curB].end())) //如果该边未执行；
            {
                executedCEList[curB].emplace(lastB); //标记为已执行；
                AvailableBBList.emplace(curB);       //如果已执行则必可到达；

                EvaluateAllPhisInBlock(lastB, curB); //处理此边相关phi函数；

                if (executedCEList[curB].size() == 1) //无其他进入curB的已执行边；
                {
                    //遍历curB内所有指令；
                    EvaluateBlock(lastB, curB);
                    //添加后继块入CFGworkList；
                    for (auto itn = g_bbL.find(g_sscpS.now_func, curB)->next.begin(); itn != g_bbL.find(g_sscpS.now_func, curB)->next.end(); itn++)
                    {
                        CFGworkList[itn->second.index].emplace(curB);
                    }
                }
            }
        }
        if (!SSAworkList.empty())
        {
            //取出并删除一个边；
            string curV = SSAworkList.begin()->first, lastV;
            if (SSAworkList.begin()->second.size() == 0)
            {
                cout << "函数: " << g_sscpS.now_func << "存在空数据流边：" << SSAworkList.begin()->first << endl;
                SSAworkList.erase(curV);
                curV = SSAworkList.begin()->first;
            }

            lastV = *SSAworkList.begin()->second.begin()->in.begin();
            SSAEdge tmpe = *SSAworkList.begin()->second.begin();
            SSAworkList[curV].erase(tmpe); //工作表中删除此边；

            //条件保护；该语句所在块所有前驱块均被执行方可执行；？？
            int cflag = 1, curB = tmpe.edgeIR->localBB;
            cflag = executedCEList.find(curB) != executedCEList.end() ? 1 : 0;
            if (cflag)
            {
                //遍历判断；
                for (auto itsu = g_sscpS.find(curV)->useSite.begin(); itsu != g_sscpS.find(curV)->useSite.end(); itsu++)
                {
                    curB = itsu->codePr->localBB;
                    for (auto it = g_bbL.find(g_sscpS.now_func, curB)->preds.begin(); it != g_bbL.find(g_sscpS.now_func, curB)->preds.end(); it++)
                    {
                        if (executedCEList[curB].find(*it) == executedCEList[curB].end())
                            cflag = 0;
                    }
                }
            } //判断所有前驱是否已全部被执行；

            //语句处理；
            if (cflag)
            {
                if (tmpe.op == "=") //正常赋值语句；
                {
                    EvaluateAssign(tmpe.edgeIR);
                }
                else if (tmpe.op == "bCont") //条件跳转语句；
                {
                    EvaluateConditional(tmpe.edgeIR);
                }
                else if (tmpe.op == "Phi") // phi翻译语句；
                {
                    EvaluatePhi(tmpe.edgeIR);
                }
                //添加后继,在模块化函数中实现；
            }
        }
    }
}

void SCCPropagation()
{
    std::unordered_map<string, unordered_map<int, struct basic_block *>>::iterator it = g_bbL.glo_list.begin();

    if (g_bbL.glo_list.find(string("glo")) != g_bbL.glo_list.end())
    {
    }

    for (; it != g_bbL.glo_list.end(); it++) //遍历所有函数；
    {
        if (it->first != "glo")
        {
            SSAworkList.clear();
            constTList.clear();
            // cout << it->first << ":\n";
            g_sscpS.now_func = it->first;
            // DisplayGCPStruct();

            // if (float_flag == 0)
            //     AssignFold();
            // DisplayGCPStruct();

            // cout << it->first << ":\n";
            FuncSCCPropagation(); // 以函数为单位运行SSCP传播；
            // DisplayGCPStruct();

            SCCPCodeDelete(); //改指令与重写代码；
        }
    }

    g_sscpS.now_func = "glo";
}
